/*
 * Libraries and headers for PDC release 3.3 (C) 1989 Lionel Hummel.
 * PDC Software Distribution (C) 1989 Lionel Hummel and Paul Petersen.
 * PDC I/O Library (C) 1987 by J.A. Lydiatt.
 *
 * This code is freely redistributable upon the conditions that this 
 * notice remains intact and that modified versions of this file not
 * be included as part of the PDC Software Distribution without the
 * express consent of the copyright holders.  No warrantee of any
 * kind is provided with this code.  For further information, contact:
 *
 *  PDC Software Distribution    Internet:                     BIX:
 *  P.O. Box 4006             or hummel@cs.uiuc.edu            lhummel
 *  Urbana, IL  61801-8801       petersen@uicsrd.csrd.uiuc.edu
 */

/*
 * used in isalpha(), isupper(), islower(), and elsewhere in ctype.h
 *
 * Here are the defines responsible for forming the individual masks:
 *
 *      #define _UPPER       (0x01)
 *      #define _LOWER       (0x02)
 *      #define _HEXIT       (0x04)
 *      #define _DIGIT       (0x08)
 *      #define _SPACE       (0x10)
 *      #define _CNTRL       (0x20)
 *      #define _PUNCT       (0x40)
 *      #define _OCTIT       (0x80)
 */ 

char _ctype[256] = {
0x20,	0x20,	0x20,	0x20,	/*	NUL	SOH	STX	ETX	*/
0x20,	0x20,	0x20,	0x20,	/*	EOT	ENQ	ACK	BEL	*/
0x20,	0x30,	0x30,	0x30,	/*	BS	HT	LF	VT	*/
0x30,	0x30,	0x20,	0x20,	/*	FF	CR	SO	SI	*/
0x20,	0x20,	0x20,	0x20,	/*	DLE	DC1	DC2	DC3	*/
0x20,	0x20,	0x20,	0x20,	/*	DC4	NAK	SYN	ETB	*/
0x20,	0x20,	0x20,	0x20,	/*	CAN	EM	SUB	ESC	*/
0x20,	0x20,	0x20,	0x20,	/*	FS	GS	RS	US	*/
0x90,	0x40,	0x40,	0x40,	/*	SP	!	"	#	*/
0x40,	0x40,	0x40,	0x40,	/*	$	%	&	'	*/
0x40,	0x40,	0x40,	0x40,	/*	(	)	*	+	*/
0x40,	0x40,	0x40,	0x40,	/*	,	-	.	/	*/
0x0C,	0x0C,	0x0C,	0x0C,	/*	0	1	2	3	*/
0x0C,	0x0C,	0x0C,	0x0C,	/*	4	5	6	7	*/
0x0C,	0x0C,	0x40,	0x40,	/*	8	9	:	;	*/
0x40,	0x40,	0x40,	0x40,	/*	<	=	>	?	*/
0x40,	0x05,	0x05,	0x05,	/*	@	A	B	C	*/
0x05,	0x05,	0x05,	0x01,	/*	D	E	F	G	*/
0x01,	0x01,	0x01,	0x01,	/*	H	I	J	K	*/
0x01,	0x01,	0x01,	0x01,	/*	L	M	N	O	*/
0x01,	0x01,	0x01,	0x01,	/*	P	Q	R	S	*/
0x01,	0x01,	0x01,	0x01,	/*	T	U	V	W	*/
0x01,	0x01,	0x01,	0x40,	/*	X	Y	Z	[	*/
0x40,	0x40,	0x40,	0x40,	/*	\	]	^	_	*/
0x40,	0x06,	0x06,	0x06,	/*	`	a	b	c	*/
0x06,	0x06,	0x06,	0x02,	/*	d	e	f	g	*/
0x02,	0x02,	0x02,	0x02,	/*	h	i	j	k	*/
0x02,	0x02,	0x02,	0x02,	/*	l	m	n	o	*/
0x02,	0x02,	0x02,	0x02,	/*	p	q	r	s	*/
0x02,	0x02,	0x02,	0x02,	/*	t	u	v	w	*/
0x02,	0x02,	0x02,	0x40,	/*	x	y	z	{	*/
0x40,	0x40,	0x40,	0x20,	/*	|	}	~	DEL	*/

/* non-ASCII values from the International Character Code follow: 	*/

0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x20,	0x20,	0x20,	0x20,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
0x00,	0x00,	0x00,	0x00,	/*		*/
} ;
